## ros-rolling-uncrustify-vendor 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(uncrustify_vendor)

option(FORCE_BUILD_VENDOR_PKG
  "Build uncrustify from source, even if system-installed package is available"
  OFF)

find_package(ament_cmake REQUIRED)

macro(build_uncrustify)
  set(extra_cmake_args)
  if(DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()
  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
    if(ANDROID)
      if(DEFINED ANDROID_ABI)
        list(APPEND extra_cmake_args "-DANDROID_ABI=${ANDROID_ABI}")
      endif()
      if(DEFINED ANDROID_CPP_FEATURES)
        list(APPEND extra_cmake_args "-DANDROID_CPP_FEATURES=${ANDROID_CPP_FEATURES}")
      endif()
      if(DEFINED ANDROID_FUNCTION_LEVEL_LINKING)
        list(APPEND extra_cmake_args "-DANDROID_FUNCTION_LEVEL_LINKING=${ANDROID_FUNCTION_LEVEL_LINKING}")
      endif()
      if(DEFINED ANDROID_NATIVE_API_LEVEL)
        list(APPEND extra_cmake_args "-DANDROID_NATIVE_API_LEVEL=${ANDROID_NATIVE_API_LEVEL}")
      endif()
      if(DEFINED ANDROID_NDK)
        list(APPEND extra_cmake_args "-DANDROID_NDK=${ANDROID_NDK}")
      endif()
      if(DEFINED ANDROID_STL)
        list(APPEND extra_cmake_args "-DANDROID_STL=${ANDROID_STL}")
      endif()
      if(DEFINED ANDROID_TOOLCHAIN_NAME)
        list(APPEND extra_cmake_args "-DANDROID_TOOLCHAIN_NAME=${ANDROID_TOOLCHAIN_NAME}")
      endif()
    endif()
  endif()

  include(ExternalProject)

  # Get uncrustify 0.72.0
  ExternalProject_Add(uncrustify-0.72.0
    GIT_REPOSITORY https://github.com/uncrustify/uncrustify.git
    GIT_TAG uncrustify-0.72.0
    GIT_CONFIG advice.detachedHead=false
    # Suppress git update due to https://gitlab.kitware.com/cmake/cmake/-/issues/16419
    # See https://github.com/ament/uncrustify_vendor/pull/22 for details
    UPDATE_COMMAND ""
    TIMEOUT 600
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install
      ${extra_cmake_args}
      -Wno-dev
    PATCH_COMMAND
      ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn ${CMAKE_CURRENT_SOURCE_DIR}/install-patch.diff
  )

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}
    USE_SOURCE_PERMISSIONS
  )
endmacro()

execute_process(
  COMMAND uncrustify --version
  RESULT_VARIABLE res
  OUTPUT_VARIABLE out
  ERROR_VARIABLE err
  OUTPUT_STRIP_TRAILING_WHITESPACE
  ERROR_STRIP_TRAILING_WHITESPACE
)
set(need_local_build FALSE)
if(NOT res EQUAL 0)
  set(need_local_build TRUE)
else()
  # Before 0.65 uncrustify used a different versioning scheme so the regex won't match
  string(REGEX REPLACE "^Uncrustify-(.*)_f$" "\\1" version_prefix_match "${out}")
  if(version_prefix_match STREQUAL "" OR version_prefix_match VERSION_LESS 0.72)
    set(need_local_build TRUE)
  endif()
endif()
if(FORCE_BUILD_VENDOR_PKG OR need_local_build)
  build_uncrustify()
endif()

# this ensures that the package has an environment hook setting the PATH
ament_package()

=== debian/changelog ===
ros-rolling-uncrustify-vendor (2.0.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Audrow Nash <audrow@openrobotics.org>  Fri, 17 Dec 2021 18:30:50 -0000

=== debian/control ===
Source: ros-rolling-uncrustify-vendor
Section: misc
Priority: optional
Maintainer: Audrow Nash <audrow@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), git, ros-rolling-ament-cmake, uncrustify, ros-rolling-ros-workspace
Homepage: https://github.com/uncrustify/uncrustify
Standards-Version: 3.9.2

Package: ros-rolling-uncrustify-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uncrustify, ros-rolling-ros-workspace
Description: Wrapper around uncrustify, providing nothing but a dependency on uncrustify, on some systems.
 On others, it provides an ExternalProject build of uncrustify.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-uncrustify-vendor//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-uncrustify-vendor 2.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(uncrustify_vendor)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_vendor_package REQUIRED)

function(check_uncrustify RESULT PROGRAM)
  execute_process(
    COMMAND ${PROGRAM} --version
    RESULT_VARIABLE res
    OUTPUT_VARIABLE out
    ERROR_QUIET
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT res EQUAL 0)
    set(${RESULT} FALSE PARENT_SCOPE)
  else()
    # Before 0.65 uncrustify used a different versioning scheme so the regex won't match
    string(REGEX REPLACE "^Uncrustify-(.*)_f$" "\\1" version_prefix_match "${out}")
    if(NOT version_prefix_match OR version_prefix_match VERSION_LESS 0.72)
      set(${RESULT} FALSE PARENT_SCOPE)
    endif()
  endif()
endfunction()

find_program(UNCRUSTIFY uncrustify)
if(UNCRUSTIFY)
  # TODO: Switch to VALIDATOR in CMake 3.25
  check_uncrustify(UNCRUSTIFY ${UNCRUSTIFY})
endif()

ament_vendor(uncrustify_vendor
  SATISFIED ${UNCRUSTIFY}
  VCS_URL https://github.com/uncrustify/uncrustify.git
  VCS_VERSION uncrustify-0.72.0
  PATCHES patches
  CMAKE_ARGS
    -DNoGitVersionString=ON
)

ament_package()

=== debian/changelog ===
ros-rolling-uncrustify-vendor (2.2.1-1jammy) jammy; urgency=high

  * Switch to ament_cmake_vendor_package (#34 <https://github.com/ament/uncrustify_vendor/issues/34>)
  * Contributors: Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.2.0-1jammy) jammy; urgency=high



 -- Scott K Logan <scott@openrobotics.org>  Fri, 28 Apr 2023 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.1.2-1jammy) jammy; urgency=high

  * [rolling] Update maintainers - 2022-11-07 (#31 <https://github.com/ament/uncrustify_vendor/issues/31>)
  * Contributors: Audrow Nash

 -- Scott K Logan <scott@openrobotics.org>  Tue, 14 Feb 2023 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.1.1-1jammy) jammy; urgency=high

  * Mirror rolling to master
  * Contributors: Audrow Nash

 -- Scott K Logan <scott@openrobotics.org>  Tue, 13 Sep 2022 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.1.0-1jammy) jammy; urgency=high

  * 2.1.0
  * Contributors: Audrow Nash

 -- Scott K Logan <scott@openrobotics.org>  Fri, 29 Apr 2022 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.0.2-1jammy) jammy; urgency=high

  * Use git hash for uncrustify_vendor (#30 <https://github.com/ament/uncrustify_vendor/issues/30>)
    CMake ExternalProject_add recommends using a specific git hash with
    GIT_TAG because branches and tags can be updated to point to different
    references.
    https://cmake.org/cmake/help/latest/module/ExternalProject.html
  * Contributors: Shane Loretz

 -- Scott K Logan <scott@openrobotics.org>  Mon, 28 Mar 2022 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.0.1-1jammy) jammy; urgency=high

  * Quiet down build warning on Windows. (#29 <https://github.com/ament/uncrustify_vendor/issues/29>)
    When building on Windows, uncrustify doesn't seem to use the
    CMAKE_BUILD_TYPE variable and thus prints a warning about it.
    Quiet that down with --no-warn-unused-cli.
  * Contributors: Chris Lalancette

 -- Scott K Logan <scott@openrobotics.org>  Tue, 01 Mar 2022 00:00:00 -0000

ros-rolling-uncrustify-vendor (2.0.0-1jammy) jammy; urgency=high

  * Update to uncrustify 0.72 (#27 <https://github.com/ament/uncrustify_vendor/issues/27>)
    * Update to uncrustify 0.72
  * Update maintainers to Audrow Nash (#25 <https://github.com/ament/uncrustify_vendor/issues/25>)
  * Contributors: Audrow Nash, Chris Lalancette

 -- Scott K Logan <scott@openrobotics.org>  Fri, 17 Dec 2021 00:00:00 -0000

ros-rolling-uncrustify-vendor (1.5.3-1jammy) jammy; urgency=high

  * Add an override flag to force vendored build (#23 <https://github.com/ament/uncrustify_vendor/issues/23>)
  * Contributors: Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Thu, 18 Mar 2021 00:00:00 -0000

ros-rolling-uncrustify-vendor (1.5.2-1jammy) jammy; urgency=high

  * Revert "Add git checkout before patching."
    This reverts commit c61408170a84ed6bc31e641fc8a2467ca5830884.
    This is no longer necessary because of UDPATE_DISCONNECTED, which will
    make the download step act more like using a URL instead of a
    GIT_REPOSITORY.
  * Make git upstream act more like tar (#22 <https://github.com/ament/uncrustify_vendor/issues/22>)
    Some of our problems with using GIT_REPOSITORY with a GIT_TAG stem from
    CMake trying to "update" the repository each time the target is
    evaluated. This would be important if not for the fact that we're
    targeting a specific REF, so the repository will never be out-of-date
    unless we change the ref, which would invalidate the target anyway.
    We can safely use UPDATE_DISCONNECTED to block the update step from
    invalidating the source target, which should prevent downstream targets
    like patch, build, and install from being re-triggered unnecessarily.
    The one caveat to this is that a change to GIT_TAG doesn't invalidate
    the target like a change to GIT_REPOSITORY or URL would. To work around
    this, I updated the target name to contain the ref instead of the
    supposed version number, which will then force a new build if we change
    the ref in the future. This is also more correct, since it would be easy
    for the ref and target name to get out of sync.
  * Revert "Use explicit INSTALL_COMMAND to suppress DESTDIR"
    This reverts commit ca32b1eb8f77b982be9d82fc186bd7d98ce2c45a.
    Evidently this wasn't working correctly on Windows.
  * Contributors: Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Mon, 01 Feb 2021 14:42:00 -0000

ros-rolling-uncrustify-vendor (1.5.1-1jammy) jammy; urgency=high

  * Use explicit INSTALL_COMMAND to suppress DESTDIR (#21 <https://github.com/ament/uncrustify_vendor/issues/21>)
    The DESTDIR environment variable is used on UNIX systems during an
    invocation of 'make install' to specify an alternate directory prefix
    for installation paths. Since this isn't a cross-platform mechanism,
    the CMAKE_INSTALL_PREFIX CMake variable can also be used.
    Unfortunately, if both of these are specified, they will both be
    applied. This isn't typically a problem, but can cause problems for the
    installation phase of ExternalProject_Add if the external project is
    built during an invocation of 'make install' with DESTDIR set.
    Since the CMAKE_INSTALL_PREFIX method is employed by the call to
    ExternalProject_Add instead of DESTDIR, we should specifically suppress
    DESTDIR if it is set so that it doesn't interfere with the installation
    of the external project to the staging directory.
  * Add git checkout before patching. (#20 <https://github.com/ament/uncrustify_vendor/issues/20>)
    This ensures that on subsequent runs, if the patch step is run
    again it will successfully repatch.
  * Contributors: Chris Lalancette, Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Mon, 01 Feb 2021 11:26:00 -0000

ros-rolling-uncrustify-vendor (1.5.0-1jammy) jammy; urgency=high



=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: ros-rolling-uncrustify-vendor
 Section: misc
 Priority: optional
-Maintainer: Audrow Nash <audrow@openrobotics.org>
-Build-Depends: debhelper (>= 9.0.0), git, ros-rolling-ament-cmake, uncrustify, ros-rolling-ros-workspace
+Maintainer: Scott K Logan <scott@openrobotics.org>
+Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-vendor-package, uncrustify, ros-rolling-ros-workspace
 Homepage: https://github.com/uncrustify/uncrustify
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
